(function($, bh, websql) {

	var DB_VERSION_NUMBER = '1.0';
	var TIME_UPDATE = 'TIME_UPDATE';
	var TIME_PUBDATE = 'TIME_PUBDATE';
	var TIME_UPDATE_SLIDER = 'TIME_UPDATE_SLIDER';
	var TIME_INTERVAL = 1000 * 60 * 5; //更新间隔(默认十分钟)
	var TIME_INTERVAL_SLIDER = 1000 * 60 * 60; //更新间隔(默认一小时)

	var PAGE_SIZE = 10;
	var MAX_INTEGER = Number.MAX_VALUE;

	var REGEX_SRC = /src=[\'\"]?([^\'\"]*)[\'\"]?/i;

	var DIR_IMAGE = "_doc/image/bh/";
//  var SOURCE_SERVER_URL = 'http://59.60.7.150:20000/edu';
//  var SERVER_URL = 'http://59.60.7.150:20000/edu/edu/mobile/services.do';
//	var SERVER_URL = 'http://api.babyhours.com/WebServers/DataService.ashx';
//	本地缓存定义开始
	var SQL_TABLE = 'DROP TABLE IF EXISTS kr_news;CREATE TABLE kr_news (guid TEXT PRIMARY KEY, title TEXT,author TEXT,link TEXT,cover TEXT,image TEXT,pubDate INTEGER,description TEXT);';
	var SQL_SELECT = 'SELECT guid,title,author,pubDate,cover,image FROM kr_news WHERE pubDate < ? ORDER BY pubDate DESC LIMIT ?;';
	var SQL_INSERT = 'INSERT INTO kr_news(title,author,link,guid,cover,pubDate,description) VALUES(?,?,?,?,?,?,?);';
	var SQL_SELECT_DETAIL = 'SELECT * FROM kr_news WHERE guid = ? LIMIT 1;';
	var SQL_UPDATE = 'UPDATE kr_news SET image = ? WHERE guid = ?';
	var SQL_DELETE = 'DELETE FROM kr_news';
//---本地缓存表定义结束
	var UNITS = {
		'年': 31557600000,
		'月': 2629800000,
		'天': 86400000,
		'小时': 3600000,
		'分钟': 60000,
		'秒': 1000
	};
	//服务端校验用户手机号
	bh.SERVER_CHECK_USER_PHONE='checkuserphone';
	//发送验证码
	bh.SERVER_SEND_VERIFY_CODE='sendverifycode';
	//校验验证码
	bh.SERVER_CHECK_VERIFY_CODE='checkverifycode';
	

	//var serverip="http://59.60.7.150:20000";
	var serverip="http://36.101.208.36";
	//路径
	bh.SOURCE_SERVER_URL = serverip+'/edu';
	//路径
	bh.SOURCE_SERVER_URL_VIDEO = serverip;
	
	//请求URL
    bh.SERVER_URL = serverip+'/edu/edu/mobile/services.do';
    //login
    bh.SERVER_URL_LOGIN = serverip+'/edu/app/pub/Logon.do';
	
	bh.SERVER_URL_UPDATE="http://192.168.1.103/update.json?random="+(new Date().getTime());//获取升级描述文件服务器地址
	
	
//	--时间格式
	bh.humanize = function(milliseconds) {
		var humanize = '';
		$.each(UNITS, function(unit, value) {
			if (milliseconds >= value) {
				humanize = Math.floor(milliseconds / value) + unit + '前';
				return false;
			}
			return true;
		});
		return humanize || '刚刚';
	};
	bh.format = function(milliseconds) {
		var diff = Date.now() - milliseconds;
		if (diff < UNITS['天']) {
			return bh.humanize(diff);
		}
		var date = new Date(milliseconds);
		var _format = function(number) {
			return (number < 10 ? ('0' + number) : number);
		};
		return date.getFullYear() + '/' + _format(date.getMonth() + 1) + '/' + _format(date.getDay()) + '-' + _format(date.getHours()) + ':' + _format(date.getMinutes());
	};
//	--时间格式结束
	bh.dbReady = function(successCallback, errorCallback) {
		html5sql.openDatabase("ubao", "babyhours", 5 * 1024 * 1024);
		if (html5sql.database.version === '') {
			html5sql.changeVersion('', DB_VERSION_NUMBER, SQL_TABLE, function() {
				successCallback && successCallback(true);
			}, function(error, failingQuery) {
				errorCallback && errorCallback(error, failingQuery);
			});
		} else {
			successCallback && successCallback(false);
		}
	};
	
	bh.clearCache = function() {
		plus.nativeUI.showWaiting('正在删除缓存...');
		bh.deleteNews(function() {
			//清除图片缓存
			plus.io.resolveLocalFileSystemURL(DIR_IMAGE, function(entry) {
				entry.removeRecursively(function() {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast("缓存删除成功");
				}, function() {
					plus.nativeUI.closeWaiting();
				});
			}, function(e) {
				plus.nativeUI.closeWaiting();
			});
			
			plus.storage.removeItem(TIME_UPDATE); //移除上次更新时间
			plus.storage.removeItem(TIME_PUBDATE); //移除最新的feed更新时间
			plus.storage.removeItem(TIME_UPDATE_SLIDER); //移除上次slider更新时间
			//通知首页重新拉取最新
			plus.webview.getWebviewById("list").evalJS('getFeed("true")');
		}, function() {});
	};
	bh.downloadImage = function(name, imgUrl, successCallback, errorCallback) {
		var url = DIR_IMAGE + name.substr(-2) + "/" +
			name + (imgUrl.substring(imgUrl.lastIndexOf('.'), imgUrl.length - 7));
		return plus.downloader.createDownload(imgUrl, {
			filename: url
		}, function(download, status) {
			successCallback(download.filename);
		});
	};

	bh.checkNetworkCon=function()
	{
		if (plus.networkinfo.getCurrentType() === plus.networkinfo.CONNECTION_NONE) {
			plus.nativeUI.toast('似乎已断开与互联网的连接', {
				verticalAlign: 'top'
			});
			return false;
		}
		else
		    return true;
	};
//	---发送数据到服务器
    bh.SendRequestByGet=function(action,data,successCallback, errorCallback)
    {
    	if(bh.checkNetworkCon())
    	{ 
    		plus.nativeUI.showWaiting();
	    	mui.getJSON(bh.SERVER_URL+"?method="+action,data,function (response) {
	    	 		 
					if(response.RTN.status==1){
					    successCallback&& successCallback(response);
					}
					else
					{
						plus.nativeUI.toast(response.RTN.message);
						errorCallback&&errorCallback(response);
					}
			});
		}
    };
    //	---发送数据到服务器
    bh.SendRequestByPost=function(action,data,successCallback,errorCallback,async)
    { 
    	
    	if(bh.checkNetworkCon())
    	{  
    		if(action!="logLearnLog")
    		{
    			plus.nativeUI.showWaiting();
    		} 
//  		console.log("debug-posturl:"+bh.SERVER_URL+"?method="+action);
//  		console.log("debug-otherparam:"+JSON.stringify(data));
    		var requrl="";
    		if(action=="getUserMobile"||action=="stuRegJobHot"||action=="checkLoginName"||action=="register"||action=="getAllNotice")
    		{ 
    			requrl=bh.SERVER_URL_LOGIN+"?method="+action; 
    		}
    		else
    		{
    			var acc="";
    			if(app.getState().token!=undefined&&app.getState().token!="")
    			{
    				acc="&access_token="+app.getState().token;
    			}
    			requrl=bh.SERVER_URL+"?method="+action+acc;
    		}  
    		mui.ajaxSettings.contentType = "application/x-www-form-urlencoded;charset=UTF-8;";
    	   // console.log(mui.ajaxSettings.contentType);
    		if(async!=false&&async!='false')//异步
    		{
		    	mui.post(requrl,data,function (response) {  
		    		    NotData(response,action); 
						if(response.RTN.status=="1"){ 
						    successCallback&& successCallback(response);
						}
						else
						{ 
							plus.nativeUI.toast(response.RTN.status_msg);
							errorCallback&&errorCallback(response);
						}
				});
			}
    		else
    		{ 
    			//同步
    			mui.ajax(requrl,{
    				data:data,
					dataType:'json',
					type:"POST",
					timeout:30000,
					async: false,
					success:function (response) { 
						if(response.RTN.status=="1"){
						    successCallback&& successCallback(response);
						}
						else
						{
							plus.nativeUI.toast(response.RTN.status_msg);
							errorCallback&&errorCallback(response);
						}
					}
    			});
    		}
		}
    };
    
	function NotData(response,action) {
//		if(action="required" || action=="choice"||action=="learnLogList"|| action=="queryOnlineAnswer" || action=="examLog"||action=="queryErrorRecord")
//		{
//			 return;
//		}
		if(action=="getChapterByCourseId"||action=="getGrades"||action=="getMyGrades"||action=="exerciseList")
		{
		    if (response.TABLE_NAME == undefined) {
		        var nodata = document.getElementById("div-not-data");
		        if (nodata == undefined || nodata == null) {
		            var dv = document.createElement("div");
		            dv.setAttribute("id", "div-not-data");
		            dv.className= "div-not-data";
		            dv.setAttribute("align", "center");
		            dv.setAttribute("style", "display: block; position: absolute;top:50%;left:50%;margin-left: -10%;margin-top: -10%; text-align: center;vertical-align:middle; width: 20%;height: 20%;");
		            var img = "<img width='100%'  src='../images/nodata.png' />";
		            dv.innerHTML = img;
		            document.body.appendChild(dv);
		           // console.log(dv.outerHTML);
		        }
		    } else {
		        var nodata = document.getElementById("div-not-data");
		        if (nodata != undefined && nodata != null) nodata.parentNode.removeChild(nodata);
		    }
	    }
	}
	
   $.ajaxSettings.error=function(xhr, type, errorThrown){
   	   
   	   try{
   	   		var msg=JSON.parse(xhr.responseText).msg;
   	   		plus.nativeUI.toast(msg);
   	   }catch(e){
   	   	   plus.nativeUI.toast('连接超时,请稍后再试');
   	   }
 	   
// 	    if (xhr.status == 200) {
//              var ct = xhr.getResponseHeader("content-type") || "",
//              xml = type === "xml" || !type && ct.indexOf("xml") >= 0,
//              data = xml ? xhr.responseXML : xhr.responseText;
//              if (xml && data.documentElement.nodeName === "parsererror") {
//                  jQuery.error("parsererror");
//              }
//              if (s && s.dataFilter) {
//                  data = s.dataFilter(data, type);
//              }
//              func(data);
//				console.log(xhr.responseXML);
//				console.log(xhr.responseText);
//          }
//          else {
                
//          }
   };
   $.ajaxSettings.complete = function(xhr, status) {
					plus.nativeUI.closeWaiting();
				}
//	---用户相关结束
})(mui, bh, html5sql);